package tests;

import java.util.Date;

public class Description {
    
    public Description(Date Creation,Date Publication,Date Renovation,String pSubject,String pTitle) {
        
        if( pSubject == null ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pSubject.trim().length() == 0 ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pTitle == null ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pTitle.trim().length() == 0 ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
            
        mCreation = new Date(0);
        mPublication = new Date(0);
        mRenovation = new Date(0);
        mSubject = new String(pSubject);
        mTitle = new String(pTitle);
    }
    
    public Date GetCreation() {
        return (Date)mCreation.clone();
    }
    
     public Date GetPublication() {
        return (Date)mPublication.clone();
    }
    
     public Date GetRenovation() {
        return (Date)mRenovation.clone();
    }
     
    public String GetSubject() {
        return new String(mSubject);
    }
    
    public String GetTitle() {
        return new String(mTitle);
    }
    
    public Description( 
            Description pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument." );
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mCreation = pPrototype.GetCreation();
        mPublication = pPrototype.GetPublication();
        mRenovation = pPrototype.GetRenovation();
        mSubject = new String( pPrototype.mSubject );
        mTitle = new String( pPrototype.mTitle );
    }
     
    public Description clone() {
        
        Description lClone = null;
        try {
            lClone =  new Description( this );
        } catch ( IllegalArgumentException eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Description ) {
            Description lInstance = ( Description )pInstance;
            if( lInstance.mCreation.equals(mCreation) &&
                    lInstance.mPublication.equals(mPublication) &&
                    lInstance.mRenovation.equals(mRenovation) &&
                    lInstance.mSubject.equals(mSubject) &&
                    lInstance.mTitle.equals(mTitle)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    Date mCreation;
    Date mPublication;
    Date mRenovation;
    String mSubject;
    String mTitle;
}

